/// <reference types="node" />
import IConsole from 'modloader64_api/IConsole';
import { IHiResTexture } from 'modloader64_api/IHiResTexture';
import IMemory from 'modloader64_api/IMemory';
import { IRomHeader } from 'modloader64_api/IRomHeader';
import { IRomMemory } from 'modloader64_api/IRomMemory';
import ISaveState from 'modloader64_api/ISaveState';
import IUtils from 'modloader64_api/IUtils';
import { Debugger } from 'modloader64_api/Sylvain/Debugger';
import { IImGui } from 'modloader64_api/Sylvain/ImGui';
import { Input } from 'modloader64_api/Sylvain/Input';
import { SDL } from 'modloader64_api/Sylvain/SDL';
import { IYaz0 } from 'modloader64_api/Sylvain/Yaz0';
import { ILogger, IConfig } from 'modloader64_api/IModLoaderAPI';
import { DolphinMemory } from './DolphinMemory';
import { DolphinStartInfo } from './DolphinStartInfo';
export default class DolphinConsole implements IConsole {
    startInfo: DolphinStartInfo;
    romName: string;
    rom: Buffer;
    mem: DolphinMemory;
    frame: number;
    callbacks: Map<string, Array<Function>>;
    lobby: string;
    logger: ILogger;
    constructor(rom: string, logger: ILogger, lobby: string, config: IConfig);
    onNewFrame(): void;
    startEmulator(preStartCallback: Function): IMemory;
    stopEmulator(): void;
    softReset(): void;
    hardReset(): void;
    saveState(file: string): void;
    loadState(file: string): void;
    finishInjects(): void;
    isEmulatorReady(): boolean;
    getLoadedRom(): Buffer;
    getRomOriginalSize(): number;
    getRomHeader(): IRomHeader;
    pauseEmulator(): void;
    resumeEmulator(): void;
    getMemoryAccess(): IMemory;
    setSaveDir(path: string): void;
    getUtils(): IUtils;
    getFrameCount(): number;
    setFrameCount(num: number): void;
    private registerCallback;
    on(which: string, callback: any): void;
    getSaveStateManager(): ISaveState;
    getImGuiAccess(): IImGui;
    getSDLAccess(): SDL;
    getGfxAccess(): any;
    getInputAccess(): Input;
    getYaz0Encoder(): IYaz0;
    getDebuggerAccess(): Debugger;
    getHiResTextureAccess(): IHiResTexture;
    getInternalPlugin(): string;
    getRomAccess(): IRomMemory;
}
//# sourceMappingURL=DolphinConsole.d.ts.map