/// <reference types="node" />
import IConsole from 'modloader64_api/IConsole';
import IMemory from 'modloader64_api/IMemory';
import { IRomHeader } from 'modloader64_api/IRomHeader';
import IUtils from 'modloader64_api/IUtils';
import ISaveState from 'modloader64_api/ISaveState';
import { Debugger } from 'modloader64_api/Sylvain/Debugger';
import { IYaz0 } from 'modloader64_api/Sylvain/Yaz0';
import { Input } from 'modloader64_api/Sylvain/Input';
import { Gfx } from 'modloader64_api/Sylvain/Gfx';
import { SDL } from 'modloader64_api/Sylvain/SDL';
import { IImGui } from 'modloader64_api//Sylvain/ImGui';
import { FakeMemory } from 'modloader64_api/SidedProxy/FakeMemory';
import { IConfig, ILogger } from 'modloader64_api/IModLoaderAPI';
import { IRomMemory } from 'modloader64_api/IRomMemory';
import { IHiResTexture } from 'modloader64_api/IHiResTexture';
export declare class FakeGamecube implements IConsole {
    rom: string;
    rom_data: Buffer;
    ram: FakeMemory;
    dummy: any;
    constructor(rom: string, logger: ILogger, lobby: string, config: IConfig);
    getHiResTextureAccess(): IHiResTexture;
    getRomAccess(): IRomMemory;
    getInternalPlugin(): string;
    getDebuggerAccess(): Debugger;
    getRomOriginalSize(): number;
    getYaz0Encoder(): IYaz0;
    getInputAccess(): Input;
    getGfxAccess(): Gfx;
    getSDLAccess(): SDL;
    getImGuiAccess(): IImGui;
    on(which: string, callback: any): void;
    startEmulator(preStartCallback: Function): IMemory;
    stopEmulator(): void;
    finishInjects(): void;
    isEmulatorReady(): boolean;
    getLoadedRom(): Buffer;
    getFrameCount(): number;
    setFrameCount(num: number): void;
    pauseEmulator(): void;
    resumeEmulator(): void;
    getRomHeader(): IRomHeader;
    getMemoryAccess(): IMemory;
    softReset(): void;
    hardReset(): void;
    saveState(file: string): void;
    loadState(file: string): void;
    setSaveDir(path: string): void;
    getUtils(): IUtils;
    getSaveStateManager(): ISaveState;
}
//# sourceMappingURL=FakeGamecube.d.ts.map