"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FakeGamecube = void 0;
const FakeMemory_1 = require("modloader64_api/SidedProxy/FakeMemory");
const GCRomHeader_1 = require("./GCRomHeader");
class FakeGamecube {
    rom;
    rom_data;
    ram;
    dummy = {};
    constructor(rom, logger, lobby, config) {
        this.rom = rom;
        this.rom_data = Buffer.alloc(1);
        this.ram = new FakeMemory_1.FakeMemory();
    }
    getHiResTextureAccess() {
        return this.dummy;
    }
    getRomAccess() {
        return new FakeMemory_1.FakeRom();
    }
    getInternalPlugin() {
        return "";
    }
    getDebuggerAccess() {
        return this.dummy;
    }
    getRomOriginalSize() {
        return -1;
    }
    getYaz0Encoder() {
        return this.dummy;
    }
    getInputAccess() {
        return this.dummy;
    }
    getGfxAccess() {
        return this.dummy;
    }
    getSDLAccess() {
        return this.dummy;
    }
    getImGuiAccess() {
        return this.dummy;
    }
    on(which, callback) {
    }
    startEmulator(preStartCallback) {
        preStartCallback(this.rom_data);
        return this.ram;
    }
    stopEmulator() { }
    finishInjects() { }
    isEmulatorReady() {
        return true;
    }
    getLoadedRom() {
        return this.rom_data;
    }
    getFrameCount() {
        return -1;
    }
    setFrameCount(num) { }
    pauseEmulator() { }
    resumeEmulator() { }
    getRomHeader() {
        return new GCRomHeader_1.GCRomHeader();
    }
    getMemoryAccess() {
        return this.ram;
    }
    softReset() { }
    hardReset() { }
    saveState(file) { }
    loadState(file) { }
    setSaveDir(path) { }
    getUtils() {
        return this.dummy;
    }
    getSaveStateManager() {
        return this.dummy;
    }
}
exports.FakeGamecube = FakeGamecube;
//# sourceMappingURL=FakeGamecube.js.map