"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImGuiAppImpl = void 0;
const dolphin_js_1 = require("dolphin-js");
const ImGuiApp_1 = require("./ImGuiApp");
const ml64tk_1 = require("ml64tk");
class ImGuiAppImpl extends ImGuiApp_1.ImGuiApp {
    hostWorker;
    mem1View = new ml64tk_1.ImGui.MemoryEditor();
    framecallback;
    Mem1;
    constructor() {
        super('ImGui', true);
    }
    onInit() {
        ml64tk_1.ImGui.getIO().iniFilename = 'data/dolphin_imgui.ini';
    }
    onNewFrame() {
        if (!dolphin_js_1.Core.isRunningAndStarted() || !this.appWindow.isVisible())
            return;
        if (this.Mem1 === undefined) {
            this.Mem1 = Buffer.from(dolphin_js_1.AddressSpace.get(3 /* AddressSpace.Type.Mem1 */));
        }
        else {
            this.mem1View.drawWindow('Mem1', this.Mem1.buffer, this.Mem1.buffer.byteLength);
        }
        // new imgui frame
        this.framecallback();
    }
    onClose() {
        this.hostWorker.postMessage({ 'msg': 'notifyHideImGui' });
        return !dolphin_js_1.Core.isRunningAndStarted();
    }
    setHostWorker(w) {
        this.hostWorker = w;
    }
    show() {
        this.appWindow.show();
    }
    hide() {
        this.appWindow.hide();
    }
    close() {
        this.appWindow.close();
    }
}
exports.ImGuiAppImpl = ImGuiAppImpl;
//# sourceMappingURL=ImGuiAppImpl.js.map